import mysql.simplesql as sql


def insertActionPanel(actionpanel):
    yield sql.Insert(table='actionpanel', values={
        'actionpanelcode': actionpanel.get('actionpanelcode', 0),
        'context': actionpanel.get('context', 0),
        'page': actionpanel.get('page', 0),
        'rowcount': actionpanel.get('rowcount', 0),
        'columncount': actionpanel.get('columncount', 0),
    })
    actionpanelitemcodes = map(lambda actionpanelitem: actionpanelitem.get('actionpanelitemcode', 0),
            actionpanel.get('actionpanelitems', []))
    yield sql.DeleteNotNestedItems(table='actionpanelitem', mainCodeField='actionpanelcode',
            mainCodeValue=actionpanel.get('actionpanelcode', 0), nestedCodeField='actionpanelitemcode',
            nestedCodeIn=actionpanelitemcodes)
    for r in actionpanel.get('actionpanelitems',):
        yield sql.Insert(table='actionpanelitem', values={
            'actionpanelitemcode': r.get('actionpanelitemcode', 0),
            'actionpanelcode': actionpanel.get('actionpanelcode', 0),
            'actioncode': r.get('actioncode', 0),
            'row': r.get('row', 0),
            'column': r.get('column', 0),
            'rowspan': r.get('rowspan', None),
            'columnspan': r.get('columnspan', None),
            'color': r.get('color', None),
            'name': r.get('name', None),
        })


def deleteActionPanel(actionpanel):
    yield sql.Delete(table='actionpanel',
            whereFields=['actionpanelcode'],
            whereValues=[actionpanel.get('actionpanelcode', 0)])
                     
    yield sql.Delete(table='actionpanelitem',
            whereFields=['actionpanelcode'],
            whereValues=[actionpanel.get('actionpanelcode', 0)])


def clearActionPanel():
    yield sql.DeleteAll(table='actionpanel')
    yield sql.DeleteAll(table='actionpanelitem')


def deleteActionPanelByCode(actionpanelcode):
    yield sql.Delete(table='actionpanel', whereFields=['actionpanelcode'], whereValues=[actionpanelcode])
    yield sql.Delete(table='actionpanelitem', whereFields=['actionpanelcode'], whereValues=[actionpanelcode])
