import mysql.simplesql as sql

tables = ['menu', 'menuitem']


def insertMenu(menu):
    yield sql.Insert(table='menu', values={
        'menucode': menu.get('menucode', 0),
        'menuname': menu.get('menuname', None),
    })
    yield sql.Delete(table='menuitem', whereFields=['menucode'], whereValues=[menu.get('menucode', 0)])
    for r in menu.get('menuitems', []):
        yield sql.Insert(table='menuitem', values={
            'menuitemorder': r.get('menuitemorder', None),
            'cmactioncode': r.get('cmactioncode', None),
            'menucode': menu.get('menucode', 0),
        })


def deleteMenu(menu):
    yield sql.Delete(table='menu', whereFields=['menucode'], whereValues=[menu.get('menucode', 0)])
    yield sql.Delete(table='menuitem', whereFields=['menucode'], whereValues=[menu.get('menucode', 0)])


def clearMenu():
    yield sql.DeleteAll(table='menu')
    yield sql.DeleteAll(table='menuitem')


def deleteMenuByCode(code):
    yield sql.Delete(table='menu', whereFields=['menucode'], whereValues=[code])
    yield sql.Delete(table='menuitem', whereFields=['menucode'], whereValues=[code])
